unit NTRegisterEventSource;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TNTRegisterEventSource = class(TComponent)
  private
    { Private declarations }
    FTypeFlags:Integer;
    FFileName:String;
    FCategory:String;
    FServer:String;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property TypeFlags:Integer read FTypeFlags write FTypeFlags default 0;
    property FileName:String read FFileName write FFileName;
    property Category:String read FCategory write FCategory;
    property Server:String read FServer write FServer;
    function Execute:Boolean;
  end;

procedure Register;

implementation

function TNTRegisterEventSource.Execute:Boolean;
var
   MyKey:HKEY;
   dwData:DWORD;
   AppPath:Array[0..250] Of Char;
begin
     // create key for this app in the event-log
     If RegCreateKey(HKEY_LOCAL_MACHINE,PChar('SYSTEM\CurrentControlSet\Services\EventLog\' + FCategory + '\' + ExtractFileName(FFileName)),MyKey)<>ERROR_SUCCESS Then
     Begin
          Result:=False;
          Exit;
     End;

     // Set the Event ID message-file name
     StrPCopy(AppPath,FFileName);

     // Add the Event ID message-file name to the subkey
     If RegSetValueEx(MyKey,PChar('EventMessageFile'),0,REG_EXPAND_SZ,@AppPath,StrLen(AppPath)+ 1)<>ERROR_SUCCESS Then
     Begin
          Result:=False;
          Exit;
     End;

     // Set the supported types flags
     dwData:=FTypeFlags;

     If RegSetValueEx(MyKey,PChar('TypesSupported'),0,REG_DWORD,@dwData,SizeOf(DWORD))<>ERROR_SUCCESS Then
     Begin
          Result:=False;
          Exit;
     End;
     RegCloseKey(MyKey);
     Result:=True;
end;

procedure Register;
begin
  RegisterComponents('NT Tools - EventLog', [TNTRegisterEventSource]);
end;

end.
