unit NTServerGetInfo;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, NTSecurityDecls;

type
  TNTServerGetInfo = class(TComponent)
  private
    { Private declarations }
    FServer:String;
    FPlatformID:DWORD;
    FName:String;
    FMajor:DWORD;
    FMinor:DWORD;
    FType:DWORD;
    FComment:String;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property Server:String read FServer write FServer;
    property PlatformID:DWORD read FPlatformID;
    property Name:String read FName;
    property MajorVersion:DWORD read FMajor;
    property MinorVersion:DWORD read FMinor;
    property ServerType:DWORD read FType;
    property Comment:String read FComment;
    function Execute:LongInt;
  end;

Type _SERVER_INFO_101=record
	sv101_platform_id:Integer;
	sv101_name:PWideChar;
	sv101_version_major:Integer;
	sv101_version_minor:Integer;
	sv101_type:Integer;
	sv101_comment:PWideChar;
End;


procedure Register;

implementation

function TNTServerGetInfo.Execute:LongInt;
var PM:Pointer;
    tServer:Array[0..255] Of WideChar;
begin
     StringToWideChar(FServer,@tServer,SizeOf(tServer));
     // Important Note:
     // Windows NT/2000/XP - PM pointer is allocated by Windows
     // Windows 95/98/Me - The caller must allocate PM buffer
     Result:=NetServerGetInfo(@tServer,101,PM);
     If Result=0 Then
     Begin
          FPlatFormID:=SERVER_INFO_101(PM^).sv101_platform_id;
          FName:=WideCharToString(SERVER_INFO_101(PM^).sv101_name);
          FMajor:=SERVER_INFO_101(PM^).sv101_version_major;
          FMinor:=SERVER_INFO_101(PM^).sv101_version_minor;
          FType:=SERVER_INFO_101(PM^).sv101_type;
          FComment:=WideCharToString(SERVER_INFO_101(PM^).sv101_comment);
     End;
     NetAPIBufferFree(PM);
end;

procedure Register;
begin
  RegisterComponents('NT Tools - Server', [TNTServerGetInfo]);
end;

end.
