unit NTTools;

interface

const

PARMNUM_ALL             =0;
PARM_ERROR_UNKNOWN      =-1;
PARM_ERROR_NONE         =0;
PARMNUM_BASE_INFOLEVEL  =1000;
PWLEN                   =256;

//
//  Bit masks for field usriX_flags of USER_INFO_X (X = 0/1).
//
UF_SCRIPT               =$0001;
UF_ACCOUNTDISABLE       =$0002;
UF_HOMEDIR_REQUIRED     =$0008;
UF_LOCKOUT              =$0010;
UF_PASSWD_NOTREQD       =$0020;
UF_PASSWD_CANT_CHANGE   =$0040;

//
// Account type bits as part of usri_flags.
//
UF_TEMP_DUPLICATE_ACCOUNT       =$0100;
UF_NORMAL_ACCOUNT               =$0200;
UF_INTERDOMAIN_TRUST_ACCOUNT    =$0800;
UF_WORKSTATION_TRUST_ACCOUNT    =$1000;
UF_SERVER_TRUST_ACCOUNT         =$2000;

UF_MACHINE_ACCOUNT_MASK=(UF_INTERDOMAIN_TRUST_ACCOUNT or UF_WORKSTATION_TRUST_ACCOUNT or UF_SERVER_TRUST_ACCOUNT);
UF_ACCOUNT_TYPE_MASK=(UF_TEMP_DUPLICATE_ACCOUNT or UF_NORMAL_ACCOUNT or UF_INTERDOMAIN_TRUST_ACCOUNT or UF_WORKSTATION_TRUST_ACCOUNT or UF_SERVER_TRUST_ACCOUNT);

UF_DONT_EXPIRE_PASSWD           =$10000;
UF_MNS_LOGON_ACCOUNT            =$20000;

UF_SETTABLE_BITS=(UF_SCRIPT or UF_ACCOUNTDISABLE or UF_LOCKOUT or UF_HOMEDIR_REQUIRED  or UF_PASSWD_NOTREQD or UF_PASSWD_CANT_CHANGE or UF_ACCOUNT_TYPE_MASK or UF_DONT_EXPIRE_PASSWD or UF_MNS_LOGON_ACCOUNT);

//
// bit masks for the NetUserEnum filter parameter.
//
FILTER_TEMP_DUPLICATE_ACCOUNT       =$0001;
FILTER_NORMAL_ACCOUNT               =$0002;
FILTER_INTERDOMAIN_TRUST_ACCOUNT    =$0008;
FILTER_WORKSTATION_TRUST_ACCOUNT    =$0010;
FILTER_SERVER_TRUST_ACCOUNT         =$0020;

//
// bit masks for the NetUserGetLocalGroups flags
//
LG_INCLUDE_INDIRECT         =$0001;

//
//  Bit masks for field usri2_auth_flags of USER_INFO_2.
//
AF_OP_PRINT             =$1;
AF_OP_COMM              =$2;
AF_OP_SERVER            =$4;
AF_OP_ACCOUNTS          =$8;
AF_SETTABLE_BITS        =(AF_OP_PRINT or AF_OP_COMM or AF_OP_SERVER or AF_OP_ACCOUNTS);

//
//  UAS role manifests under NETLOGON
//
UAS_ROLE_STANDALONE     =0;
UAS_ROLE_MEMBER         =1;
UAS_ROLE_BACKUP         =2;
UAS_ROLE_PRIMARY        =3;

//
//  Values for ParmError for NetUserSetInfo.
//
USER_NAME_PARMNUM               =1;
USER_PASSWORD_PARMNUM           =3;
USER_PASSWORD_AGE_PARMNUM       =4;
USER_PRIV_PARMNUM               =5;
USER_HOME_DIR_PARMNUM           =6;
USER_COMMENT_PARMNUM            =7;
USER_FLAGS_PARMNUM              =8;
USER_SCRIPT_PATH_PARMNUM        =9;
USER_AUTH_FLAGS_PARMNUM         =10;
USER_FULL_NAME_PARMNUM          =11;
USER_USR_COMMENT_PARMNUM        =12;
USER_PARMS_PARMNUM              =13;
USER_WORKSTATIONS_PARMNUM       =14;
USER_LAST_LOGON_PARMNUM         =15;
USER_LAST_LOGOFF_PARMNUM        =16;
USER_ACCT_EXPIRES_PARMNUM       =17;
USER_MAX_STORAGE_PARMNUM        =18;
USER_UNITS_PER_WEEK_PARMNUM     =19;
USER_LOGON_HOURS_PARMNUM        =20;
USER_PAD_PW_COUNT_PARMNUM       =21;
USER_NUM_LOGONS_PARMNUM         =22;
USER_LOGON_SERVER_PARMNUM       =23;
USER_COUNTRY_CODE_PARMNUM       =24;
USER_CODE_PAGE_PARMNUM          =25;
USER_PRIMARY_GROUP_PARMNUM      =51;
USER_PROFILE                    =52; // ?? Delete when convenient
USER_PROFILE_PARMNUM            =52;
USER_HOME_DIR_DRIVE_PARMNUM     =53;

//
// the new infolevel counterparts of the old info level + parmnum
//
USER_NAME_INFOLEVEL               =(PARMNUM_BASE_INFOLEVEL + USER_NAME_PARMNUM);
USER_PASSWORD_INFOLEVEL           =(PARMNUM_BASE_INFOLEVEL + USER_PASSWORD_PARMNUM);
USER_PASSWORD_AGE_INFOLEVEL       =(PARMNUM_BASE_INFOLEVEL + USER_PASSWORD_AGE_PARMNUM);
USER_PRIV_INFOLEVEL               =(PARMNUM_BASE_INFOLEVEL + USER_PRIV_PARMNUM);
USER_HOME_DIR_INFOLEVEL           =(PARMNUM_BASE_INFOLEVEL + USER_HOME_DIR_PARMNUM);
USER_COMMENT_INFOLEVEL            =(PARMNUM_BASE_INFOLEVEL + USER_COMMENT_PARMNUM);
USER_FLAGS_INFOLEVEL              =(PARMNUM_BASE_INFOLEVEL + USER_FLAGS_PARMNUM);
USER_SCRIPT_PATH_INFOLEVEL        =(PARMNUM_BASE_INFOLEVEL + USER_SCRIPT_PATH_PARMNUM);
USER_AUTH_FLAGS_INFOLEVEL         =(PARMNUM_BASE_INFOLEVEL + USER_AUTH_FLAGS_PARMNUM);
USER_FULL_NAME_INFOLEVEL          =(PARMNUM_BASE_INFOLEVEL + USER_FULL_NAME_PARMNUM);
USER_USR_COMMENT_INFOLEVEL        =(PARMNUM_BASE_INFOLEVEL + USER_USR_COMMENT_PARMNUM);
USER_PARMS_INFOLEVEL              =(PARMNUM_BASE_INFOLEVEL + USER_PARMS_PARMNUM);
USER_WORKSTATIONS_INFOLEVEL       =(PARMNUM_BASE_INFOLEVEL + USER_WORKSTATIONS_PARMNUM);
USER_LAST_LOGON_INFOLEVEL         =(PARMNUM_BASE_INFOLEVEL + USER_LAST_LOGON_PARMNUM);
USER_LAST_LOGOFF_INFOLEVEL        =(PARMNUM_BASE_INFOLEVEL + USER_LAST_LOGOFF_PARMNUM);
USER_ACCT_EXPIRES_INFOLEVEL       =(PARMNUM_BASE_INFOLEVEL + USER_ACCT_EXPIRES_PARMNUM);
USER_MAX_STORAGE_INFOLEVEL        =(PARMNUM_BASE_INFOLEVEL + USER_MAX_STORAGE_PARMNUM);
USER_UNITS_PER_WEEK_INFOLEVEL     =(PARMNUM_BASE_INFOLEVEL + USER_UNITS_PER_WEEK_PARMNUM);
USER_LOGON_HOURS_INFOLEVEL        =(PARMNUM_BASE_INFOLEVEL + USER_LOGON_HOURS_PARMNUM);
USER_PAD_PW_COUNT_INFOLEVEL       =(PARMNUM_BASE_INFOLEVEL + USER_PAD_PW_COUNT_PARMNUM);
USER_NUM_LOGONS_INFOLEVEL         =(PARMNUM_BASE_INFOLEVEL + USER_NUM_LOGONS_PARMNUM);
USER_LOGON_SERVER_INFOLEVEL       =(PARMNUM_BASE_INFOLEVEL + USER_LOGON_SERVER_PARMNUM);
USER_COUNTRY_CODE_INFOLEVEL       =(PARMNUM_BASE_INFOLEVEL + USER_COUNTRY_CODE_PARMNUM);
USER_CODE_PAGE_INFOLEVEL          =(PARMNUM_BASE_INFOLEVEL + USER_CODE_PAGE_PARMNUM);
USER_PRIMARY_GROUP_INFOLEVEL      =(PARMNUM_BASE_INFOLEVEL + USER_PRIMARY_GROUP_PARMNUM);
USER_HOME_DIR_DRIVE_INFOLEVEL     =(PARMNUM_BASE_INFOLEVEL + USER_HOME_DIR_DRIVE_PARMNUM);

//
//  For SetInfo call (parmnum 0) when password change not required
//
NULL_USERSETINFO_PASSWD     ='              ';

TIMEQ_FOREVER               =-1;
USER_MAXSTORAGE_UNLIMITED   =-1;
USER_NO_LOGOFF              =-1;
UNITS_PER_DAY               =24;
UNITS_PER_WEEK              =UNITS_PER_DAY * 7;

//
// Privilege levels (USER_INFO_X field usriX_priv (X = 0/1)).
//
USER_PRIV_MASK      =$3;
USER_PRIV_GUEST     =0;
USER_PRIV_USER      =1;
USER_PRIV_ADMIN     =2;

//
// user modals related defaults
//
MAX_PASSWD_LEN      =PWLEN;
DEF_MIN_PWLEN       =6;
DEF_PWUNIQUENESS    =5;
DEF_MAX_PWHIST      =8;
DEF_MAX_PWAGE       =TIMEQ_FOREVER;               // forever
DEF_MIN_PWAGE       =0;                           // 0 days
DEF_FORCE_LOGOFF    =$ffffffff;                   // never
DEF_MAX_BADPW       =0;                           // no limit
ONE_DAY             =01*24*3600;                  // 01 day

//
// User Logon Validation (codes returned)
//
VALIDATED_LOGON         =0;
PASSWORD_EXPIRED        =2;
NON_VALIDATED_LOGON     =3;
VALID_LOGOFF            =1;

//
// parmnum manifests for user modals
//
MODALS_MIN_PASSWD_LEN_PARMNUM             =1;
MODALS_MAX_PASSWD_AGE_PARMNUM             =2;
MODALS_MIN_PASSWD_AGE_PARMNUM             =3;
MODALS_FORCE_LOGOFF_PARMNUM               =4;
MODALS_PASSWD_HIST_LEN_PARMNUM            =5;
MODALS_ROLE_PARMNUM                       =6;
MODALS_PRIMARY_PARMNUM                    =7;
MODALS_DOMAIN_NAME_PARMNUM                =8;
MODALS_DOMAIN_ID_PARMNUM                  =9;
MODALS_LOCKOUT_DURATION_PARMNUM           =10;
MODALS_LOCKOUT_OBSERVATION_WINDOW_PARMNUM =11;
MODALS_LOCKOUT_THRESHOLD_PARMNUM          =12;

//
// the new infolevel counterparts of the old info level + parmnum
//
MODALS_MIN_PASSWD_LEN_INFOLEVEL   =(PARMNUM_BASE_INFOLEVEL + MODALS_MIN_PASSWD_LEN_PARMNUM);
MODALS_MAX_PASSWD_AGE_INFOLEVEL   =(PARMNUM_BASE_INFOLEVEL + MODALS_MAX_PASSWD_AGE_PARMNUM);
MODALS_MIN_PASSWD_AGE_INFOLEVEL   =(PARMNUM_BASE_INFOLEVEL + MODALS_MIN_PASSWD_AGE_PARMNUM);
MODALS_FORCE_LOGOFF_INFOLEVEL     =(PARMNUM_BASE_INFOLEVEL + MODALS_FORCE_LOGOFF_PARMNUM);
MODALS_PASSWD_HIST_LEN_INFOLEVEL  =(PARMNUM_BASE_INFOLEVEL + MODALS_PASSWD_HIST_LEN_PARMNUM);
MODALS_ROLE_INFOLEVEL             =(PARMNUM_BASE_INFOLEVEL + MODALS_ROLE_PARMNUM);
MODALS_PRIMARY_INFOLEVEL          =(PARMNUM_BASE_INFOLEVEL + MODALS_PRIMARY_PARMNUM);
MODALS_DOMAIN_NAME_INFOLEVEL      =(PARMNUM_BASE_INFOLEVEL + MODALS_DOMAIN_NAME_PARMNUM);
MODALS_DOMAIN_ID_INFOLEVEL        =(PARMNUM_BASE_INFOLEVEL + MODALS_DOMAIN_ID_PARMNUM);

//
// Special Values and Constants - Group
//
GROUPIDMASK                 =$8000;      // MSB set if uid refers

//
// Predefined group for all normal users, administrators and guests
// LOCAL is a special group for pinball local security.
//
GROUP_SPECIALGRP_USERS      ='USERS';
GROUP_SPECIALGRP_ADMINS     ='ADMINS';
GROUP_SPECIALGRP_GUESTS     ='GUESTS';
GROUP_SPECIALGRP_LOCAL      ='LOCAL';

//
// parmnum manifests for SetInfo calls (only comment is settable)
//
GROUP_ALL_PARMNUM           =0;
GROUP_NAME_PARMNUM          =1;
GROUP_COMMENT_PARMNUM       =2;
GROUP_ATTRIBUTES_PARMNUM    =3;

//
// the new infolevel counterparts of the old info level + parmnum
//
GROUP_ALL_INFOLEVEL               =(PARMNUM_BASE_INFOLEVEL + GROUP_ALL_PARMNUM);
GROUP_NAME_INFOLEVEL              =(PARMNUM_BASE_INFOLEVEL + GROUP_NAME_PARMNUM);
GROUP_COMMENT_INFOLEVEL           =(PARMNUM_BASE_INFOLEVEL + GROUP_COMMENT_PARMNUM);
GROUP_ATTRIBUTES_INFOLEVEL        =(PARMNUM_BASE_INFOLEVEL + GROUP_ATTRIBUTES_PARMNUM);

LOCALGROUP_NAME_PARMNUM          =1;
LOCALGROUP_COMMENT_PARMNUM       =2;

//
// Maximum number of permission entries for each resource.
//
MAXPERMENTRIES      =64;

//
//  Bit values for the access permissions.  ACCESS_ALL is a handy
//  way to specify maximum permissions.  These are used in
//  acl_access field of access_list structures.
//
ACCESS_NONE         =0;
ACCESS_READ         =$01;
ACCESS_WRITE        =$02;
ACCESS_CREATE       =$04;
ACCESS_EXEC         =$08;
ACCESS_DELETE       =$10;
ACCESS_ATRIB        =$20;
ACCESS_PERM         =$40;
ACCESS_GROUP        =$8000;
ACCESS_ALL          =(ACCESS_READ or ACCESS_WRITE or ACCESS_CREATE or ACCESS_EXEC or ACCESS_DELETE or ACCESS_ATRIB or ACCESS_PERM);

//
// Bit values for the acc1_attr field of the ACCESS_INFO_1 structure.
//
ACCESS_AUDIT                    =$1;
ACCESS_SUCCESS_OPEN             =$10;
ACCESS_SUCCESS_WRITE            =$20;
ACCESS_SUCCESS_DELETE           =$40;
ACCESS_SUCCESS_ACL              =$80;
ACCESS_SUCCESS_MASK             =$F0;
ACCESS_FAIL_OPEN                =$100;
ACCESS_FAIL_WRITE               =$200;
ACCESS_FAIL_DELETE              =$400;
ACCESS_FAIL_ACL                 =$800;
ACCESS_FAIL_MASK                =$F00;
ACCESS_FAIL_SHIFT               =4;

//
// Parmnum value for NetAccessSetInfo.
//
ACCESS_RESOURCE_NAME_PARMNUM    =1;
ACCESS_ATTR_PARMNUM             =2;
ACCESS_COUNT_PARMNUM            =3;
ACCESS_ACCESS_LIST_PARMNUM      =4;

//
// the new infolevel counterparts of the old info level + parmnum
//
ACCESS_RESOURCE_NAME_INFOLEVEL    =(PARMNUM_BASE_INFOLEVEL + ACCESS_RESOURCE_NAME_PARMNUM);
ACCESS_ATTR_INFOLEVEL             =(PARMNUM_BASE_INFOLEVEL + ACCESS_ATTR_PARMNUM);
ACCESS_COUNT_INFOLEVEL            =(PARMNUM_BASE_INFOLEVEL + ACCESS_COUNT_PARMNUM);
ACCESS_ACCESS_LIST_INFOLEVEL      =(PARMNUM_BASE_INFOLEVEL + ACCESS_ACCESS_LIST_PARMNUM);

//
// ACCESS_LETTERS defines a letter for each bit position in
// the acl_access field of struct access_list.  Note that some
// bits have a corresponding letter of ' ' (space).
//
ACCESS_LETTERS      ='RWCXDAP         ';

//
// FunctionCode values for I_NetLogonControl.
//
// NOTE : if you change the following NETLOGON_CONTROL_* values,
// change them in netsvcdllslogonsrvlogon.idl file also.
//

NETLOGON_CONTROL_QUERY                        =1;    // No-op: just query
NETLOGON_CONTROL_REPLICATE                    =2;    // Force replicate on BDC
NETLOGON_CONTROL_SYNCHRONIZE                  =3;    // Force synchronize on BDC
NETLOGON_CONTROL_PDC_REPLICATE                =4;    // Force PDC to broadcast change
NETLOGON_CONTROL_REDISCOVER                   =5;    // Force to re-discover trusted domain DCs
NETLOGON_CONTROL_TC_QUERY                     =6;    // Query status of specified trusted channel status
NETLOGON_CONTROL_TRANSPORT_NOTIFY             =7;    // Notify netlogon that a new transport has come online
NETLOGON_CONTROL_FIND_USER                    =8;    // Find named user in a trusted domain

// Debug function codes
NETLOGON_CONTROL_UNLOAD_NETLOGON_DLL          =$FFFB;
NETLOGON_CONTROL_BACKUP_CHANGE_LOG            =$FFFC;
NETLOGON_CONTROL_TRUNCATE_LOG                 =$FFFD;
NETLOGON_CONTROL_SET_DBFLAG                   =$FFFE;
NETLOGON_CONTROL_BREAKPOINT                   =$FFFF;

//
// Values of netlog1_flags
//
NETLOGON_REPLICATION_NEEDED                   =$01;  // Database is out of date
NETLOGON_REPLICATION_IN_PROGRESS              =$02;  // Replication is happening now
NETLOGON_FULL_SYNC_REPLICATION                =$04;  // full sync replication required/progress
NETLOGON_REDO_NEEDED                          =$08;  // Redo of previous replication needed

implementation

end.
